'use strict'

const fs = require('fs'),
      epochUtils = require('../util/epochs'),
      _ = require('underscore'),
      chalk = require('chalk'),
      yaml = require('js-yaml'),
      Q = require('q'),
      log = require('loglevel'),
      Table = require('cli-table');

var readFile = Q.nfbind(fs.readFile);

function foo(res, epoch) {
  const resultFile = `${process.cwd()}/experiments/results/${epoch}/${res}`
  const doneFile = `${process.cwd()}/experiments/results/${epoch}/.done/${res}`
  const failedFile = `${process.cwd()}/experiments/results/${epoch}/.fail/${res}`

  // hasn't started
  let stat = 0;
  // done
  if (fs.existsSync(doneFile))
    stat = 1
  // failed
  else if (fs.existsSync(failedFile))
    stat = 2
  // still running
  else if (fs.existsSync(resultFile))
    stat = 3

  const startTime = "blah"
  const finishTime = "blah"
    
  let job = ""
  try {
    job = fs.readFileSync(`${process.cwd()}/experiments/jobs/${epoch}/${res}.job`).toString()
  } catch (e) { }

  let raw = ""
  try {
    raw = fs.readFileSync(`${process.cwd()}/experiments/results/${epoch}/${res}`).toString()
  } catch (e) { }

  return {
    name: res,
    status: stat,
    startTime: startTime,
    finishTime: finishTime,
    raw: raw,
    job: job
  }
}

function experiment(epoch) {
  const stat = epochUtils.status(epoch)

  const vcFilename = `${process.cwd()}/experiments/jobs/${epoch}/vc.yml`
  let vc = {}
  try {
    vc = yaml.safeLoad(fs.readFileSync(vcFilename))
  } catch (e) { }

  let machine = {}

  const results = _.map(stat.expected, res => { return foo(res, epoch) })

  const overallStatus = 2

  return {
    epoch: epoch,
    desc: stat.desc,
    generated: "blah",
    vc: vc,
    machine: machine,
    status: overallStatus,
    results: results
  }
}

function gather() {
  const epochs = fs.readdirSync(`${process.cwd()}/experiments/results/`)

  // Bail if empty experiment set
  if (epochs.length == 0)
    return;

  const experiments =  _.map(epochs, experiment);

  return {
    experiments: experiments
  }
}

/*function singleSummary(epoch, sample, vc, expfile) {
  // resolve actual epoch
  epoch = epochUtils.resolve(epoch)

  const stat = epochUtils.status(epoch)
  log.info(chalk.bold("Description: "), stat.desc)
  log.info(chalk.bold("Epoch:       "), epoch)
  log.info(chalk.bold("Expected:    "), stat.expected.length)
  log.info(chalk.bold("Done:        "), stat.done.length == stat.expected.length ? chalk.green(stat.done.length) : stat.done.length)
  log.info(chalk.bold("Failed:      "), stat.failed.length == 0 ? 0 : chalk.red(stat.failed.length))

  _.each(stat.failed, f => {
    log.info(chalk.bold("Failed file: "), f)
  })

  log.info("")

  // Print experiment file
  if (expfile) {
    log.info(chalk.bold.yellow("Experimental setup: "))
    const runConfig = fs.readFileSync(`${process.cwd()}/experiments/jobs/${epoch}/run.yml`).toString()
    log.info(runConfig)
  }

  // Print random job
  if (sample) {
    let epochDir = `${process.cwd()}/experiments/jobs/${epoch}`
    const jobFiles = 
      _.filter(fs.readdirSync(epochDir),
      filename => { return filename.includes('.job')}
    )

    let randomJob = jobFiles[Math.floor(Math.random()*jobFiles.length)]
    const jobFileContents = fs.readFileSync(`${process.cwd()}/experiments/jobs/${epoch}/${randomJob}`).toString()

    log.info(chalk.bold.yellow("Random job: "), `${process.cwd()}/experiments/jobs/${epoch}/${randomJob}`)
    log.info(jobFileContents)
  }

  // VC information
  if (vc) {
    const vcFilename = `${process.cwd()}/experiments/jobs/${epoch}/vc.yml`
    if (fs.existsSync(vcFilename)) {
      const vcInfo = yaml.safeLoad(fs.readFileSync(vcFilename))

      if (vcInfo.git)  {
        log.info("")
        log.info(chalk.bold.yellow("Version control: git"))
        log.info(chalk.bold("commit: ", vcInfo.git.sha))
        log.info(chalk.bold("remotes: ", vcInfo.git.remotes))
        log.info(chalk.bold(vcInfo.git.st))
        log.info(chalk.bold(vcInfo.git.diff))
      }

      if (vcInfo.exe)  {
        log.info(chalk.bold.yellow("Executable information"))
        for (const exe in vcInfo.exe) {
          log.info(chalk.bold(exe), vcInfo.exe[exe].md5)
        }
      }
    }
  }
}*/

module.exports = function(epoch) {
  const payload = gather()

  console.log(JSON.stringify(payload))
}
